# El modelo de la regresión lineal
# Fraga 
# 23.01.2023

import numpy as np
import matplotlib.pyplot as plt
from sklearn.model_selection import train_test_split

# Leo los primeros 100 renglones
A = np.loadtxt( "iris.csv", delimiter=',', skiprows=1, usecols=(0,1,4), max_rows=100  ) 

# Vamos a usar las dos primeras columnas y las dos
# primeras clases

X = A[:, 0:2] 
y = A[:, 2] 

print ( X.shape )
print ( y.shape )

# Separamos los datos de entrenamiento y de prubea

X_entrena, X_prueba, y_entrena, y_prueba = train_test_split( X, y, random_state=21 )

print( X_entrena.shape )
print( y_entrena.shape )

def phi( x, a, b) :
	return x @ a + b

vx = np.array(  [ 2.82344073, -2.68192963] )
vx = vx.T

b = -6.84330316

n, m = X_prueba.shape

i = 0
while i < n :
	y = phi( vx, X_prueba[i], b )
	if y > 0.5 :
		r = 1
	else :
		r = 0
	print( r, y_prueba[i] )

	i += 1  

# Hacemos la gráfica de los datos
vx = np.linspace(-4,7,10)

# [ 2.82344073, -2.68192963] 
# b = -6.84330316

vy = (6.84330316 - 2.82344073 * vx )/(-2.68192963)

fig, [ax1, ax2] = plt.subplots(nrows=1, ncols=2 )

ax1.scatter( X_entrena[:,0], X_entrena[:,1], c=y_entrena )
ax1.plot( vx, vy )
ax1.set_xlim( 4, 7.2 )
ax1.set_ylim( 1.8, 4.6 )

ax2.scatter( X_prueba[:,0], X_prueba[:,1], c=y_prueba )
ax2.plot( vx, vy )
ax2.set_xlim( 4, 7.2 )
ax2.set_ylim( 1.8, 4.6 )

plt.show( )

